package com.inteligr8.activiti.doclet;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

public class FluentMap<K, V> implements Map<K, V> {
	
	private Map<K, V> map;
	
	public FluentMap(Map<K, V> map) {
		this.map = map;
	}
	
	@Override
	public void clear() {
		this.map.clear();
	}
	
	@Override
	public boolean containsKey(Object key) {
		return this.map.containsKey(key);
	}
	
	@Override
	public boolean containsValue(Object value) {
		return this.map.containsValue(value);
	}
	
	@Override
	public Set<Entry<K, V>> entrySet() {
		return this.map.entrySet();
	}
	
	@Override
	public boolean equals(Object obj) {
		return this.map.equals(obj);
	}
	
	@Override
	public V get(Object key) {
		return this.map.get(key);
	}
	
	@Override
	public int hashCode() {
		return this.map.hashCode();
	}
	
	@Override
	public boolean isEmpty() {
		return this.map.isEmpty();
	}
	
	@Override
	public Set<K> keySet() {
		return this.map.keySet();
	}
	
	@Override
	public V put(K key, V value) {
		return this.map.put(key, value);
	}
	
	@Override
	public void putAll(Map<? extends K, ? extends V> m) {
		this.map.putAll(m);
	}
	
	@Override
	public V remove(Object key) {
		return this.map.remove(key);
	}
	
	@Override
	public int size() {
		return this.map.size();
	}
	
	@Override
	public Collection<V> values() {
		return this.map.values();
	}
	
	public FluentMap<K, V> with(K key, V value) {
		this.map.put(key, value);
		return this;
	}
	
	public FluentMap<K, V> without(K key) {
		this.map.remove(key);
		return this;
	}

}
