/*
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.inteligr8.activiti.doclet;

import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class MethodSignatureFreemarkerModel implements JavadocDocumentable, JavadocTaggable {
	
	private String methodSignature;
	
	private Map<String, ParamFreemarkerModel> params = new LinkedHashMap<>();

	private Map<String, FieldFreemarkerModel> bpmnFields = new LinkedHashMap<>();

	private Map<String, VarFreemarkerModel> variablesIn = new LinkedHashMap<>();

	private Map<String, VarFreemarkerModel> variablesOut = new LinkedHashMap<>();
	
	private String returnType;
	
	private Map<String, ThrowFreemarkerModel> throwTypes = new LinkedHashMap<>();
	
	private Map<String, ThrowFreemarkerModel> bpmnErrors = new LinkedHashMap<>();
	
	private String docFirstSentence;

	private String docBody;

	private Map<String, List<String>> tags = new LinkedHashMap<>();

	private List<ReferenceFreemarkerModel> seeRefs = new LinkedList<>();

	public String getMethodSignature() {
		return methodSignature;
	}

	public void setMethodSignature(String methodSignature) {
		this.methodSignature = methodSignature;
	}

	public Map<String, ParamFreemarkerModel> getParams() {
		return params;
	}

	public void setParams(Map<String, ParamFreemarkerModel> params) {
		this.params = params;
	}
	
	public Map<String, FieldFreemarkerModel> getBpmnFields() {
		return bpmnFields;
	}
	
	public void setBpmnFields(Map<String, FieldFreemarkerModel> fields) {
		this.bpmnFields = fields;
	}
	
	public Map<String, VarFreemarkerModel> getVariablesIn() {
		return variablesIn;
	}
	
	public void setVariablesIn(Map<String, VarFreemarkerModel> variablesIn) {
		this.variablesIn = variablesIn;
	}
	
	public Map<String, VarFreemarkerModel> getVariablesOut() {
		return variablesOut;
	}
	
	public void setVariablesOut(Map<String, VarFreemarkerModel> variablesOut) {
		this.variablesOut = variablesOut;
	}

	public String getReturnType() {
		return returnType;
	}

	public void setReturnType(String returnType) {
		this.returnType = returnType;
	}

	public Map<String, ThrowFreemarkerModel> getThrowTypes() {
		return throwTypes;
	}

	public void setThrowTypes(Map<String, ThrowFreemarkerModel> throwTypes) {
		this.throwTypes = throwTypes;
	}
	
	public Map<String, ThrowFreemarkerModel> getBpmnErrors() {
		return bpmnErrors;
	}
	
	public void setBpmnErrors(Map<String, ThrowFreemarkerModel> bpmnErrors) {
		this.bpmnErrors = bpmnErrors;
	}

	public String getDocFirstSentence() {
		return docFirstSentence;
	}

	public void setDocFirstSentence(String docFirstSentence) {
		this.docFirstSentence = docFirstSentence;
	}

	public String getDocBody() {
		return docBody;
	}

	public void setDocBody(String docBody) {
		this.docBody = docBody;
	}

	public Map<String, List<String>> getTags() {
		return tags;
	}

	public void setTags(Map<String, List<String>> tags) {
		this.tags = tags;
	}
	
	public List<ReferenceFreemarkerModel> getSeeRefs() {
		return seeRefs;
	}
	
	public void setSeeRefs(List<ReferenceFreemarkerModel> seeRefs) {
		this.seeRefs = seeRefs;
	}

}
