
# ${title}<#if apiName??>: ${apiName}</#if>

<#if apiName??>This file documents the ${apiName} library.  </#if>When this library is deployed in Activiti, including Alfresco Process Services, the following API can be utilized.

Activiti has a set of features that allow a model designer to call these Java-based APIs.  These can be from various tasks, listeners, and expressions.  The exposure of APIs may differ from method to method.  Those details are in this documentation.  See the table below for the various integrations between Activiti and these libraries.

| Activiti Feature                       | API Notes |
| -------------------------------------- | --------- |
| Delegate Expression                    | Any named Spring Bean that implements the `JavaDelegate` interface. |
| Expression                             | Any named Spring Bean and one of its public methods. |
| Script                                 | Any named Spring Beans and their public methods. |
| Execution Listener Delegate Expression | Any named Spring Bean that implements the `ExecutionListener` interface. |
| Execution Listener Expression          | Any named Spring Bean and its public method. |
| Task Listener Delegate Expression      | Any named Spring Bean that implements the `TaskListener` interface. |
| Task Listener Expression               | Any named Spring Bean and its public method. |

It is important to note that Activiti expressions use the JUEL language and Activiti scripts use the specified/configured language.  Popular configured languages may be JavaScript or Groovy.  In any case, the same API notation may be used.  It is also worth noting that execution/task listeners may exist on most objects.

<#if hasDelegateBeans>
## Delegates

| Delegate ID                      | Brief Documentation       |
| -------------------------------- | ------------------------- |
<#list beans as bean><#if bean.hasDelegate>
	<#assign idColumn = "[`${bean.beanId}`](bean-${bean.beanId}.md)">
| ${idColumn?right_pad(32)} | <#if bean.docFirstSentence??>${bean.docFirstSentence?right_pad(24)}<#else>No documentation available.</#if> |
</#if></#list>

</#if>
<#if hasMethodBeans>
## Beans

| Bean ID                          | Brief Documentation       |
| -------------------------------- | ------------------------- |
<#list beans as bean><#if (bean.methods?size > 0)>
	<#assign idColumn = "[`${bean.beanId}`](bean-${bean.beanId}.md)">
| ${idColumn?right_pad(32)} | <#if bean.docFirstSentence??>${bean.docFirstSentence?right_pad(24)}<#else>No documentation available.</#if> |
</#if></#list>

</#if>
---

Generated by the [Inteligr8](https://inteligr8.com) [Activiti API Doclet](https://bitbucket.org/inteligr8/activiti-api-doclet).
